/*
 *  MICO --- an Open Source CORBA implementation
 *  Copyright (c) 1997-2006 by The Mico Team
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#include <CORBA.h>

#ifndef __MTPOLICY_H__
#define __MTPOLICY_H__


#include <mico/export.h>



namespace MICOMT
{

class ServerConcurrencyModelPolicy;
typedef ServerConcurrencyModelPolicy *ServerConcurrencyModelPolicy_ptr;
typedef ServerConcurrencyModelPolicy_ptr ServerConcurrencyModelPolicyRef;
typedef ObjVar< ServerConcurrencyModelPolicy > ServerConcurrencyModelPolicy_var;
typedef ObjOut< ServerConcurrencyModelPolicy > ServerConcurrencyModelPolicy_out;

class ClientConcurrencyModelPolicy;
typedef ClientConcurrencyModelPolicy *ClientConcurrencyModelPolicy_ptr;
typedef ClientConcurrencyModelPolicy_ptr ClientConcurrencyModelPolicyRef;
typedef ObjVar< ClientConcurrencyModelPolicy > ClientConcurrencyModelPolicy_var;
typedef ObjOut< ClientConcurrencyModelPolicy > ClientConcurrencyModelPolicy_out;

class ConnectionLimitPolicy;
typedef ConnectionLimitPolicy *ConnectionLimitPolicy_ptr;
typedef ConnectionLimitPolicy_ptr ConnectionLimitPolicyRef;
typedef ObjVar< ConnectionLimitPolicy > ConnectionLimitPolicy_var;
typedef ObjOut< ConnectionLimitPolicy > ConnectionLimitPolicy_out;

class RequestLimitPolicy;
typedef RequestLimitPolicy *RequestLimitPolicy_ptr;
typedef RequestLimitPolicy_ptr RequestLimitPolicyRef;
typedef ObjVar< RequestLimitPolicy > RequestLimitPolicy_var;
typedef ObjOut< RequestLimitPolicy > RequestLimitPolicy_out;

}






namespace MICOMT
{

const ::CORBA::PolicyType SERVER_CONCURRENCY_MODEL_POLICY_TYPE = 1002;

/*
 * Base class and common definitions for local interface ServerConcurrencyModelPolicy
 */

class ServerConcurrencyModelPolicy : 
  virtual public CORBA::Object,
  virtual public ::CORBA::Policy
{
  public:
    MICO_EXPORT virtual ~ServerConcurrencyModelPolicy();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef ServerConcurrencyModelPolicy_ptr _ptr_type;
    typedef ServerConcurrencyModelPolicy_var _var_type;
    #endif

    MICO_EXPORT static ServerConcurrencyModelPolicy_ptr _narrow( CORBA::Object_ptr obj );
    MICO_EXPORT static ServerConcurrencyModelPolicy_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ServerConcurrencyModelPolicy_ptr _duplicate( ServerConcurrencyModelPolicy_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static ServerConcurrencyModelPolicy_ptr _nil()
    {
      return 0;
    }

    MICO_EXPORT virtual void *_narrow_helper( const char *repoid );

    MICO_EXPORT virtual ::MICOMT::ServerConcurrencyModel model() = 0;

  protected:
    ServerConcurrencyModelPolicy() {}
  private:
    MICO_EXPORT ServerConcurrencyModelPolicy( const ServerConcurrencyModelPolicy& );
    MICO_EXPORT void operator=( const ServerConcurrencyModelPolicy& );
};

extern MICO_EXPORT CORBA::TypeCodeConst _tc_ServerConcurrencyModelPolicy;


const ::CORBA::PolicyType CLIENT_CONCURRENCY_MODEL_POLICY_TYPE = 1003;

/*
 * Base class and common definitions for local interface ClientConcurrencyModelPolicy
 */

class ClientConcurrencyModelPolicy : 
  virtual public CORBA::Object,
  virtual public ::CORBA::Policy
{
  public:
    MICO_EXPORT virtual ~ClientConcurrencyModelPolicy();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef ClientConcurrencyModelPolicy_ptr _ptr_type;
    typedef ClientConcurrencyModelPolicy_var _var_type;
    #endif

    MICO_EXPORT static ClientConcurrencyModelPolicy_ptr _narrow( CORBA::Object_ptr obj );
    MICO_EXPORT static ClientConcurrencyModelPolicy_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ClientConcurrencyModelPolicy_ptr _duplicate( ClientConcurrencyModelPolicy_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static ClientConcurrencyModelPolicy_ptr _nil()
    {
      return 0;
    }

    MICO_EXPORT virtual void *_narrow_helper( const char *repoid );

    MICO_EXPORT virtual ::MICOMT::ClientConcurrencyModel model() = 0;

  protected:
    ClientConcurrencyModelPolicy() {}
  private:
    MICO_EXPORT ClientConcurrencyModelPolicy( const ClientConcurrencyModelPolicy& );
    MICO_EXPORT void operator=( const ClientConcurrencyModelPolicy& );
};

extern MICO_EXPORT CORBA::TypeCodeConst _tc_ClientConcurrencyModelPolicy;


const ::CORBA::PolicyType CONNECTION_LIMIT_POLICY_TYPE = 1004;

/*
 * Base class and common definitions for local interface ConnectionLimitPolicy
 */

class ConnectionLimitPolicy : 
  virtual public CORBA::Object,
  virtual public ::CORBA::Policy
{
  public:
    MICO_EXPORT virtual ~ConnectionLimitPolicy();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef ConnectionLimitPolicy_ptr _ptr_type;
    typedef ConnectionLimitPolicy_var _var_type;
    #endif

    MICO_EXPORT static ConnectionLimitPolicy_ptr _narrow( CORBA::Object_ptr obj );
    MICO_EXPORT static ConnectionLimitPolicy_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ConnectionLimitPolicy_ptr _duplicate( ConnectionLimitPolicy_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static ConnectionLimitPolicy_ptr _nil()
    {
      return 0;
    }

    MICO_EXPORT virtual void *_narrow_helper( const char *repoid );

    MICO_EXPORT virtual CORBA::ULong limit() = 0;

  protected:
    ConnectionLimitPolicy() {}
  private:
    MICO_EXPORT ConnectionLimitPolicy( const ConnectionLimitPolicy& );
    MICO_EXPORT void operator=( const ConnectionLimitPolicy& );
};

extern MICO_EXPORT CORBA::TypeCodeConst _tc_ConnectionLimitPolicy;


const ::CORBA::PolicyType REQUEST_LIMIT_POLICY_TYPE = 1005;

/*
 * Base class and common definitions for local interface RequestLimitPolicy
 */

class RequestLimitPolicy : 
  virtual public CORBA::Object,
  virtual public ::CORBA::Policy
{
  public:
    MICO_EXPORT virtual ~RequestLimitPolicy();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef RequestLimitPolicy_ptr _ptr_type;
    typedef RequestLimitPolicy_var _var_type;
    #endif

    MICO_EXPORT static RequestLimitPolicy_ptr _narrow( CORBA::Object_ptr obj );
    MICO_EXPORT static RequestLimitPolicy_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static RequestLimitPolicy_ptr _duplicate( RequestLimitPolicy_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static RequestLimitPolicy_ptr _nil()
    {
      return 0;
    }

    MICO_EXPORT virtual void *_narrow_helper( const char *repoid );

    MICO_EXPORT virtual CORBA::ULong limit() = 0;

  protected:
    RequestLimitPolicy() {}
  private:
    MICO_EXPORT RequestLimitPolicy( const RequestLimitPolicy& );
    MICO_EXPORT void operator=( const RequestLimitPolicy& );
};

extern MICO_EXPORT CORBA::TypeCodeConst _tc_RequestLimitPolicy;


}


#ifndef MICO_CONF_NO_POA



namespace POA_MICOMT
{

}


#endif // MICO_CONF_NO_POA

#endif
